#!/usr/bin/python

import os
import sys
import subprocess
import re
import threading 
import time
import pprint
import ptpcam


ptpcam_exec=os.path.expandvars("$HOME")+"/Dokumente/robo-chdk/chdk-de/tools/ptpcam/ptpcam"

class PtpcamThread(threading.Thread): 
    def __init__(self, bus, dev, cmd): 
        threading.Thread.__init__(self) 
        self.ptpcam = ptpcam.Ptpcam(bus,dev)
        self.cmd = cmd
        
    def __init__(self, ptpcam_instance, cmd): 
        threading.Thread.__init__(self) 
        self.ptpcam = ptpcam_instance
        self.cmd = cmd
 
    def run(self): 
        self.ptpcam.call(self.cmd)


        
class Timer(object):
    def __init__(self, name=None):
        self.name = name

    def __enter__(self):
        self.tstart = time.time()

    def __exit__(self, type, value, traceback):
        if self.name:
            print("[%s]" % self.name),
        print("Elapsed: %s" % (time.time() - self.tstart))

ptpcams = ptpcam.getptpcams()
if len(ptpcams) == 0:
    print("Found no PTP devices! -> Bye\n")
    exit(1)

if len(sys.argv) != 2 and len(sys.argv) != 3:
    print("Missing Argument\n")
    exit(1)

scriptfile = None
scriptlines = []
if len(sys.argv) == 2:
    try:
        scriptfile = open(sys.argv[1]);
    except IOError:
        print("Can't open File \"%s\"\n" % sys.argv[1])
        exit(1)
        
    for line in scriptfile:
        scriptlines.append(line)
        
else:
    scriptlines.append(sys.argv[2])
    

ptpcam_threads = [] 

with Timer("Worker"):
    for p in ptpcams:
        ptpcam_threads.append(PtpcamThread(p, scriptlines))
        
    for t in ptpcam_threads:
        t.start()
        
    for t in ptpcam_threads:
        t.join()
        
    for t in ptpcam_threads:
        print(t.ptpcam.ptpcam_output)